from urllib.parse import urlparse


class URI:
    def __init__(self, url_str: str):
        self.url_str = url_str

class URL(URI):
    def __init__(self, url_str: str):
        self.url_str = url_str

class URN(URI):
    def __init__(self, url_str: str):
        self.url_str = url_str


class CompositeURI(URI):
    def __init__(self, url_str: str):
        url_obj = urlparse(url_str)

        self.protocols = url_obj.scheme.split('+')[::-1]
        self.components = url_obj.scheme.split('+')[::-1]

    def core(self, layers=1) -> 'CompositeURI':
        '''
        "Core" the innermost ``layers`` layers of the composite URI.
        '''
        pass

    def shed(self, layers=1) -> 'CompositeURI':
        '''
        "Shed" the outermost ``layers`` layers of the composite URI.
        '''
        pass
