from typing import BinaryIO

from co3 import URI, Medium


class Resource:
    def __init__(
        self,
        context: Medium | list[Medium],
        uri: URI
    ):
        self.uri = uri

    def open(self) -> BinaryIO:
        pass
